#!/usr/bin/python

import os
import sys
import pickle
import socket

#if socket.gethostname()[0] == "r":
#  sys.path.append("/work/igor/lib/python/lib/python2.4/site-packages")
#  os.chdir("/work/igor/pl/run")
#  #print "Current working directory:", os.getcwd()
#elif socket.gethostname() == "igorub":
#  os.chdir("/home/igor/pl/run")
  

from twisted.internet import pollreactor, protocol
pollreactor.install()
from twisted.internet import reactor
from twisted.protocols.basic import NetstringReceiver
from twisted.internet.protocol import ServerFactory
from twisted.internet.error import CannotListenError

from pl_cc import *
from pl_irp import *
from pl_nls import *
from pl_ctrl import *
from pl_vman import *
from pl_utils import *
from pl_vnode import *
from pl_parser import *
from pl_gossip import *
from pl_con_utils import *

import pdb
import pickle
import optparse

class CommandProtocol(NetstringReceiver):
  """ Some examples:
    For a1.txt:
      $ nc localhost 55552
      $ 38:send_data_pkt;5,20502,5;2,2;10;xyz;1,5,
  """
  def __init__(self, rtr):
    self.rtr = rtr

  def connectionMade(self):
    self.peer_addr = (self.transport.getPeer( ).host, 
                      self.transport.getPeer( ).port)
    if self.rtr.opts.show_cmd_connections:
      print "Connected to cmd channel to", self.peer_addr
    self.factory.cmdConnectionMade(self)

  def connectionLost(self, reason):
    if self.rtr.opts.show_cmd_connections:
      print "Cmd connection lost to", self.peer_addr
    self.factory.cmdConnectionLost(self)

  def stringReceived(self, pkt):
    # send_data_pkt;fids;dst;ttl;data;nh
    # fail_link;peer_id
    # recover_link;peer_id
    # print lpls/apls/rib_in/rib_out/rrib_out
    ps = pkt.split(";")
    if len(ps) > 0:
      if ps[0] == "send_data_pkt":
        # send_data_pkt;fids;dst;ttl;data;nh
        # fids = comma-separated ints -> list
        # dst = two comma-separated ints -> 2-tuple
        # ttl = one int -> int
        # data = arbitrary sting not containing ";"
        # nh = two comma-separated ints -> 2-tuple
        try:
          assert len(ps) == 6
          fids = map(lambda x: int(x), ps[1].split(","))
          dst = tuple(map(lambda x: int(x), ps[2].split(",")))
          ttl = int(ps[3])
          data = ps[4]
          nh = tuple(map(lambda x: int(x), ps[5].split(",")))
          msg = PLDataMsg(fids, dst, ttl, data, nh)                  
          smsg = pickle.dumps(msg)
          self.rtr.vman.consumeRouterPacket(smsg, None, 
                                            PLIrpI.DATA_PKT_TYPE, None)
        except:
          print "malformed send_data_pkt cmd:", pkt
      elif ps[0] == "fail_link":
        # fail_link;peer_id
        # peer_id = two ints -> 2-tuple
        try:
          assert len(ps) == 2
          peer_id = tuple(map(lambda x: int(x), ps[1].split(",")))
          self.rtr.nls.fail_link(peer_id)
        except:
          print "malformed fail_link cmd:", pkt
      elif ps[0] == "recover_link":
        # recover_link;peer_id
        try:
          assert len(ps) == 2
          peer_id = tuple(map(lambda x: int(x), ps[1].split(",")))
          self.rtr.nls.recover_link(peer_id)          
        except:
          print "malformed recover_link cmd:", pkt
      elif ps[0] == "shutdown":
        self.rtr.shutDown()
      elif ps[0] == "print":
        # print;lpls/apls/rib_in/rib_out/rrib_out/all
        try:
          assert len(ps) > 1
          for atr in ps[1:]:
            if atr == "rrib_out":
              print self.rtr.gsp.getRribOutStr()
            elif atr == "rrib_out_c":
              print self.rtr.gsp.getRribOutStr(countOnly = True)
            elif atr == "rib_out":
              print self.rtr.gsp.getRibOutStr()
            elif atr == "rib_in_c":
              print self.rtr.gsp.getRibInStr(countOnly = True)
            elif atr == "rib_in":
              print self.rtr.gsp.getRibInStr()
            elif atr == "lpls_c":
              print self.rtr.gsp.getLplsStr(countOnly = True)
            elif atr == "lpls":
              print self.rtr.gsp.getLplsStr()
            elif atr == "apls_c":
              print self.rtr.gsp.getAplsStr(countOnly = True)
            elif atr == "apls":
              print self.rtr.gsp.getAplsStr()
            elif atr == "all_c":
              print "lpls:", self.rtr.gsp.getLplsStr(countOnly = True)
              print "apls:", self.rtr.gsp.getAplsStr(countOnly = True)
              print "rib_in:", self.rtr.gsp.getRibInStr(countOnly = True)
              print "rrib_out:", self.rtr.gsp.getRribOutStr(countOnly = True)
              print "rib_out:", self.rtr.gsp.getRibOutStr(countOnly = True)
            elif atr == "all":
              print self.rtr.gsp.getLplsStr()
              print self.rtr.gsp.getAplsStr()
              print self.rtr.gsp.getRibInStr()
              print self.rtr.gsp.getRribOutStr()
              print self.rtr.gsp.getRibOutStr()
            else:
              print "Unknown print object", atr
        except:
          print "malformed print cmd:", pkt
      elif ps[0] == "prints":
        # prints;msg/ctrl/fwd/hdr
        if not self.rtr.opts.collect_stats:
          print "Stats are not being collected"
        else:
          try:
            assert len(ps) > 1
            for req in ps[1:]:
              if req == "msg":
                print "adv=%d, wdr=%d, exp=%d" % \
                    (self.rtr.stats.gsp_adv_msg_count,
                     self.rtr.stats.gsp_wdr_msg_count,
                     self.rtr.stats.vnode_exp_msg_count)
              elif req == "ctrl":
                print "pls=%d, pl_mem=%d, ctrl_mem=%d" % \
                    (self.rtr.stats.pl_count,
                     self.rtr.stats.pl_mem,
                     self.rtr.stats.ctrl_mem)
              elif req == "fwd":
                print "Not Implemented"
              elif req == "hdr":
                print "Not Implemented"
              else:
                print "Unknown stats object to print:", atr
          except:
            print "malformed stats print cmd:", pkt
      elif ps[0] == "exec":
        cmd = pkt.split(";",1)[1]
        try:
          exec cmd in globals(), locals()
        except:
          print  "malformed expression to exec:", pkt.split(";",1)[1]
      elif ps[0] == "dummy":
        pass
      else:
        print "Received unknown command:", pkt


class CommandFactory(ServerFactory):
  """ 
  """
  protocol = CommandProtocol

  def __init__(self, rtr):
    self.rtr = rtr
    self.connections = [] # list of connected protocol objects

  def cmdConnectionMade(self, proto):
    assert proto not in self.connections
    self.connections.append(proto)

  def cmdConnectionLost(self, proto):
    assert proto in self.connections
    self.connections.remove(proto)

  def buildProtocol(self, addr):
    p = self.protocol(self.rtr)
    p.factory = self
    return p

class PLStats:
  """ Class that keeps track of the corresponding router's metrics
  """
  
  # Sizes in bytes.
  # While smaller sizes can be achieved, it is much harder to program with
  # variable size fields in data structure. Thus, we pick conservative maximum
  # fixed sizes to all basic types.
  ASID_SIZE = 2 # size of an as id
  FID_SIZE = 4  # size of a fwd identifier
  REF_SIZE = 4  # size of a reference/pointer
  VLID_SIZE = 6 # vnode logical id size (asid, vid)
  PID_SIZE = VLID_SIZE + FID_SIZE # size of pathlet id
  SARRAY_LEN_SIZE = 2 # We need two bytes to store the len of a small array
  BARRAY_LEN_SIZE = 4


  def __init__(self, rtr):
    self.rtr = rtr
    # msg counts
    self.gsp_adv_msg_count = 0 # number of received adv msgs
    self.gsp_wdr_msg_count = 0 # number of received wdr msgs
    self.gsp_adv_msg_hist = []
    self.gsp_wdr_msg_hist = []

    self.vnode_exp_msg_count = 0 # number of received vnode exp
    # ctrl plane memory
    self.pl_count = 0 # maximum number of pathlets in apls
    self.pl_mem = 0 # total memory needed to store just the known pathlets
    self.ctrl_mem = 0 # total maximum size of all ctrl plane memory in bytes
    # Forwarding plane memory
    self.fe_counts = {} # {vlid -> max number of forwarding entries}
    # Number of bytes in packets route, sampled periodically.
    # Each entry in the list represents the number of samples for which
    # the header was of this size (bytes). The route is the one selected 
    # by the tree building algorithm. 
    self.hdr_sizes = {} # {dst_vlid -> [number of samples of this size]}
    # sample interval for hdr_sizes in seconds
    self.sample_int = rtr.opts.collect_stats

    # schedule hdr_size updates
    # self.rtr.reactor.callLater(self.sample_int, self.hdr_size_update)
    
  def getFidSize(self, fid):
    """ fid is an integer. We return how many bytes we need to encode this
    fid together with its len in the header. The encoding we use is:
    First bit  0 -> 1 byte fid, fids in range [0, 127]
    First two 10 -> 2 byte fid, fids in range [128, 127+2^14 = 16511]
    First three 110 -> 3 byte fid, fids in range [16512, 16511+2^21=2113663]
    First three 111 -> 4 byte fid, fids in range [2113664, 538984575]
    """
    if fid < 128:
      return 1
    elif fid < 16512:
      return 2
    elif fid < 2113664:
      return 3
    else:
      return 4

  def hdr_size_update(self):
    # get the set of root vnodes. If the controller is LTOrpa, this 
    # set is the customer ingress vnode. In general, it is all ingress 
    # vnodes (vnodes we are exposing),
    assert False, "Requires modification because not all LT vnodes are created"
    rset = set()
    if isinstance(self.rtr.ctrl, PLControllerLTOrpa):
      rset.add((self.rtr.id[0], 1))
    else:
      assert False, "Not Implemented"
      for sv in self.rtr.vman.evnodes.itervalues():
        rset.update(sv)

    # build the graph
    # nodes are vlid tuples, edges are integers (number of vnode-level links),
    # only the shortest edge is added to the graph. The pid of the shortest 
    # edge in the graph is stored in pids dict - {(vlid1, vlid2) -> pid}.
    gsp = self.rtr.gsp
    g = NX.DiGraph(weighted=True)
    pids = {}
    for pid, pp in gsp.apls.iteritems():
      pl = pp.pl # pl has to be flat
      if len(pl.seq) < 2:
        continue
      lid1 = pl.seq[0]
      lid2 = pl.seq[-1]
      w = len(pl.seq) - 1
      if not g.has_edge(lid1, lid2):
        g.add_edge(lid1, lid2, w)
        pids[(lid1, lid2)] = pid
      else:
        # if the new pathlet is shorter, replace it with the old
        if g[lid1][lid2] > w:
          g.add_edge(lid1, lid2, w)
          pids[(lid1, lid2)] = pid

    # compute the shortest path tree, paths - {lid -> [lids]}
    paths = NX.single_source_dijkstra_path(g, iter(rset).next())

    def getTotFidSize(path):
      # we compute the size of fidSeq of the packet as we would send it.
      # In principle, the fidSeq size can increase as the packet travels, but
      # we cannot compute it locally. This does not happen if everybody uses
      # LT or BGP policies. It can happen however, when policies are mixed.
      # We hope that because we have data from all the routers, we should not
      # be in a big error.
      ts = 0
      for i in range(0, len(path) - 1):
        ts += self.getFidSize(gsp.apls[pids[(path[i], path[i+1])]].pl.fid)
        #print path
        #if path == [(3,1), (3,4), (2,3), (2,2), (4,5)]:
        #  print (path[i], path[i+1])
        #  print pids[(path[i], path[i+1])]
        #  print gsp.apls[pids[(path[i], path[i+1])]].pl.fid
        #  print ts
      return ts

    for dlid, path in paths.iteritems():
      ts = getTotFidSize(path)
      if dlid not in self.hdr_sizes:
        self.hdr_sizes[dlid] = []
      if len(self.hdr_sizes[dlid]) < ts + 1:
        # hdr_sizes[dlid] list need to be initialized
        for i in range(0, ts - len(self.hdr_sizes[dlid]) + 1):
          self.hdr_sizes[dlid].append(0)
      self.hdr_sizes[dlid][ts] += 1

    # reschedule ourselves
    # self.rtr.reactor.callLater(self.sample_int, self.hdr_size_update)

  def apls_changed_update(self):
    """ self.lpls: {pid -> PLPathlet} 
        self.apls: {pid -> PLPath}
        self.rib_in: {pid -> {aid -> PLPath}}
        self.rib_out: {pid -> {aid -> PLPath}}
        self.rrib_out: {pid -> set(aid)} 
    """
    # update pathlet count, pl mem, and ctrl mem
    self.pl_count = max(self.pl_count, len(self.rtr.gsp.apls))
    self.pl_mem = max(self.pl_mem, self.getCtrlPLSize())
    self.ctrl_mem = max(self.ctrl_mem, self.getCtrlMemSize())
    
  def fe_changed_update(self):
    # update fe_counts
    for vlid, vnode in self.rtr.vman.vnodes.iteritems():
      if vlid not in self.fe_counts:
        self.fe_counts[vlid] = 0
      ents = vnode.getNumEntries()
      self.fe_counts[vlid] = max(self.fe_counts[vlid], ents)
 
  def writeAll(self): 
    # open stats log file
    if hasattr(self, "logdir"):
      self.fd = open("%s/stats_%d_%d.txt" % (self.logdir, self.rtr.opts.run_id, 
                                             self.rtr.id[0]), "w")
    else:
      self.fd = open("log/stats_%d_%d.txt" % (self.rtr.opts.run_id, 
                                              self.rtr.id[0]), "w")
    f = self.fd
    f.write("ID, sample int: %d, %d\n" % (self.rtr.id[0], self.sample_int))
    f.write("Num of local pls: %d\n" % (len(self.rtr.gsp.lpls)))
    f.write("Num of rcvd adv msgs: %d\n" % (self.gsp_adv_msg_count))
    f.write("Num of rcvd wdr msgs: %d\n" % (self.gsp_wdr_msg_count))
    for i in range(0, len(self.gsp_adv_msg_hist)):
      f.write("msg-hist: %d %d %d\n" % (i, self.gsp_adv_msg_hist[i], 
                                        self.gsp_wdr_msg_hist[i]))
    f.write("Num of rcvd vnode exp msgs: %d\n" % (self.vnode_exp_msg_count))
    f.write("Max number of known pathlets: %d\n" % (self.pl_count))
    f.write("Max mem to store just pathlets: %d\n" % (self.pl_mem))
    if self.pl_count > 0:
      f.write("Max size of ctrl mem in bytes, per pl: %d, %d\n" % (
          int(self.ctrl_mem), int(self.ctrl_mem)/self.pl_count))
    else:
      f.write("Max size of ctrl mem in bytes: %d\n" % (int(self.ctrl_mem)))
    for vlid, cnt in self.fe_counts.iteritems():
      f.write("Vnode, max fwd entries: %s, %d\n" % (str(vlid), cnt))
    for dst, slist in self.hdr_sizes.iteritems():
      f.write("Dst vnode, hdr sizes: %s, %s\n" %(str(dst),str(slist)[1:-1]))

  def close(self):
    self.writeAll()
    self.fd.close()

  def getPLSize(self, pl):
    # assumes pl is flat
    return (PLStats.FID_SIZE + len(pl.seq)*PLStats.VLID_SIZE + 
            PLStats.SARRAY_LEN_SIZE)

  def getPPathSize(self, pp):
    return (self.getPLSize(pp.pl) + len(pp.aspath)*PLStats.ASID_SIZE +
            PLStats.SARRAY_LEN_SIZE)

  def getCtrlPLSize(self):
    """ This methods computes only the size needed to store the all known 
    pathlets.
    """
    cms = 0
    for pp in self.rtr.gsp.apls.itervalues():
      cms += self.getPLSize(pp.pl)
    return cms

  def getCtrlMemSize(self):
    """ This function computes the size that our implementation uses
    self.lpls: need to store the pid and reference to plpath in apls
    self.apls: need to store the pid and plpath
    self.rib_in: for each pid, need to store the pid and a list of "in" 
                 records. Each record containing the aid and the full copy 
                 of the ppath (because the aspath is different and we need 
                 to be general and allow different seqs for the same fid
    self.rib_out: for each pid, need to store the a list of "out" records.
                  Each record is an iad and a reference to ppath that was 
                  sent. 
    self.rrib_out: For each pid, we store a set of aids.
    """
    gsp = self.rtr.gsp
    # lpls size
    cms = (len(gsp.lpls)*(PLStats.PID_SIZE + PLStats.REF_SIZE) + 
           PLStats.BARRAY_LEN_SIZE)
    # apls size
    cms += PLStats.BARRAY_LEN_SIZE
    for pp in gsp.apls.itervalues():
      cms += PLStats.PID_SIZE + self.getPPathSize(pp)
    # rib_in size
    cms += PLStats.BARRAY_LEN_SIZE
    for inrecs in gsp.rib_in.itervalues():
      if len(inrecs) > 0:
        cms +=  PLStats.PID_SIZE
        for pp in inrecs.itervalues():
          cms += PLStats.ASID_SIZE + self.getPPathSize(pp)
    # rib_out state
    cms += PLStats.BARRAY_LEN_SIZE
    for outrecs in gsp.rib_out.itervalues():
      if len(outrecs) > 0:
        cms += (len(outrecs)*(PLStats.ASID_SIZE + PLStats.REF_SIZE) + 
                PLStats.PID_SIZE)
    # rrib_out state
    cms += PLStats.BARRAY_LEN_SIZE
    for routrecs in gsp.rrib_out.itervalues():
      if len(routrecs) > 0:
        cms += (len(routrecs)*PLStats.ASID_SIZE + PLStats.PID_SIZE)
    return cms


class PLRouter:
  """ Main class that represents a router and simply contains all other modules
  runtime options.

  Router state:
    reactor - reactor
    id      - (as_id, router_id)
  """
  
  def __init__(self, reactr, argv = None):
    
    if argv == None:
      argv = sys.argv

    self.reactor = reactr
    self.opts = self.readOpts(argv)
    self.id = (self.opts.asid, self.opts.rid)
    self.base_time = -1

    # setup statistics
    if self.opts.collect_stats:
      self.stats = PLStats(self)

    # Get the module names and router configuration
    modules = self.readConfig()

    # Instantiate the modules
    if "nls" in modules:
      exec "self.nls = " + modules["nls"] + "(self)"
    if "irp" in modules:
      exec "self.irp = " + modules["irp"] + "(self)"
    if "vman" in modules:
      exec "self.vman = " + modules["vman"] + "(self)"
    if "cc" in modules:
      exec "self.cc = " + modules["cc"] + "(self)"
    if "ctrl" in modules:
      exec "self.ctrl = " + modules["ctrl"] + "(self)"
    if "gsp" in modules:
      exec "self.gsp = " + modules["gsp"] + "(self)"

    # Initialize the modules that need after all modules are created
    self.ctrl.initialize()

    # setup command channel
    if 0:
      self.cmdf = CommandFactory(self)
      openedCmdPort = False
      for i in range(0, 5):
        try:
          self.reactor.listenTCP(self.nls.listen_addr[1]+5+i, self.cmdf)
        except CannotListenError:
          print "port", self.nls.listen_addr[1]+5+i, "for cmd channel was busy"
        else:
          openedCmdPort = True
          break
      if not openedCmdPort:
        print "Cmd port could not be opened"
  
    # schedule some packet sending
    self.reactor.callLater(2, self.sentDebugPacket)
    self.pkt_count = 1

  def run(self):
    self.reactor.run()

  def sentDebugPacket(self):
    if self.id == (1, 20):
      # (fids, dst, ttl, data, nh):
      msg = PLDataMsg([4, 302, 4, 202, 3], (3, 2), 225, 
                      str(self.pkt_count), (1, 3))
      smsg = pickle.dumps(msg)
      self.vman.consumeRouterPacket(smsg, None, PLIrpI.DATA_PKT_TYPE, None)
      self.reactor.callLater(2, self.sentDebugPacket)
    
  def isLocal(self, rid):
    return self.id[0] == rid[0]

  def getTOff(self, offset):
    """ Returns the time after now so that it will be the same as base_time 
        plus offset. If base_time is not set, returns offset, i.e. uses current
        time as the base_time
    """
    if self.base_time != -1:
      return self.base_time + offset - int(time.time())
    else: 
      return offset

  def shutDown(self):
    """ Close all open files, write stats, exit. Called either through a
        control
    """
    if self.opts.collect_stats:
      self.stats.close()
    self.reactor.stop()

  def linkDown(self, aid):
    if aid in self.ctrl.as2nbr:
      assert self.id[0] < aid
      peer_id = self.ctrl.as2nbr[aid]
      self.nls.fail_link(peer_id)

  def linkUp(self, aid):
    if aid in self.ctrl.as2nbr:
      assert self.id[0] < aid
      peer_id = self.ctrl.as2nbr[aid]
      self.nls.recover_link(peer_id)

  def stopReceiving(self):
    self.gsp.stopReceiving()
    self.vman.stopReceiving()
    self.irp.stopReceiving()

  def dumpFes(self, fname):
    f = open("%s_%d.txt" % (fname, self.id[0]), "w")
    vnodes = self.vman.vnodes # lid -> PLVNode
    vlist = []
    for lid, vn in vnodes.iteritems():
      vlist.append((lid, vn.fes))
    pickle.dump(vlist, f, -1)
    f.close()

  def clearCounters(self):
    if self.opts.collect_stats:
      self.stats.gsp_adv_msg_hist.append(self.stats.gsp_adv_msg_count)
      self.stats.gsp_wdr_msg_hist.append(self.stats.gsp_wdr_msg_count)
      self.stats.gsp_adv_msg_count = 0
      self.stats.gsp_wdr_msg_count = 0
    
  def dumpFesAndApls(self, fname):
    f = open("%s_%d.txt" % (fname, self.id[0]), "w")
    vnodes = self.vman.vnodes # lid -> PLVNode
    vlist = []
    pls = {}
    for lid, vn in vnodes.iteritems():
      vlist.append((lid, vn.fes))
    for pid, ppath in self.gsp.apls.iteritems():
      pls[pid] = ppath.pl
    pickle.dump([pls, vlist], f, -1)
    f.close()

  def readConfig(self):
    """ Read the configuration file and get class names to instantiate modules.
    """

    # modules whose class names we are looking for
    modules = {}

    # find the names of classes
    f = open(self.opts.conf, "r")
    in_ctrl_inst = False
    for line in f:
      line = line.strip()
      if len(line) == 0 or line[0] == "#":
        continue
      ps = line.split()

      if (len(ps) == 2 and ps[0] == "subsection" and 
          ps[1] == "controller_instances"):
        in_ctrl_inst = True
        continue

      if in_ctrl_inst:
        if ps[0] != "section" and ps[0] != "subsection" and len(ps) == 3:
          if self.id == (int(ps[0]), int(ps[1])):
            modules["ctrl"] = ps[2]
          
      if ps[0] == "section":
        assert len(ps) == 3
        if ps[2] != "none" and ps[1] != "ctrl":
          modules[ps[1]] = ps[2]

      if ps[0] == "event":
        if ps[1] == "set-base-time":
          # set the base time
          self.base_time = int(ps[2])
        elif ps[1] == "shut-down":
          # if the shutdown event is for us, schedule it
          if ps[2] == "all" or int(ps[2]) == self.id[0]:
            self.reactor.callLater(self.getTOff(int(ps[3])), self.shutDown)
        elif ps[1] == "link-down":
          # if we are the lower id'ed end of the link, schedule link down event
          a1 = int(ps[2])
          a2 = int(ps[3])
          ah = self.id[0]
          if a1 == ah or a2 == ah:
            if ah == a1:
              naid = a2
            else:
              naid = a1
            if ah < naid:
              self.reactor.callLater(self.getTOff(int(ps[4])), 
                                     self.linkDown, naid)
        elif ps[1] == "link-up":
          # if we are the lower id'ed end of the link, schedule link up event
          a1 = int(ps[2])
          a2 = int(ps[3])
          ah = self.id[0]
          if a1 == ah or a2 == ah:
            if ah == a1:
              naid = a2
            else:
              naid = a1
            if ah < naid:
              self.reactor.callLater(self.getTOff(int(ps[4])), 
                                     self.linkUp, naid)
        elif ps[1] == "stop-rcv":
          # if we are the AS to stop receiving, stop
          # event stop-rcv 1 12
          if ps[2] == "all" or int(ps[2]) == self.id[0]:
            self.reactor.callLater(self.getTOff(int(ps[3])),
                                   self.stopReceiving)
        elif ps[1] == "dump-fes":
          # if we are the router, dump the forwarding tables 
          # of all local vnodes to a file
          # event dump-fes as-id-or-all base-file-name time
          if ps[2] == "all" or int(ps[2]) == self.id[0]:
            self.reactor.callLater(self.getTOff(int(ps[4])),
                                   self.dumpFes, ps[3])
        elif ps[1] == "dump-all":
          # if we are the router, dump the forwarding tables 
          # and all known apls to a file
          # event dump-all as-id-or-all base-file-name time
          if ps[2] == "all" or int(ps[2]) == self.id[0]:
            self.reactor.callLater(self.getTOff(int(ps[4])),
                                   self.dumpFesAndApls, ps[3])
        elif ps[1] == "clear-counts":
          # event clear-counts aid-or-all time
          if ps[2] == "all" or int(ps[2]) == self.id[0]:
            self.reactor.callLater(self.getTOff(int(ps[3])),
                                   self.clearCounters)
        elif ps[1] == "logdir":
          # event logdir log/400_ltc
          if self.opts.collect_stats:
            self.stats.logdir = ps[2] 

      # has to be last
      if in_ctrl_inst:
        if ps[0] == "section" or ps[0] == "subsection":
          in_ctrl_inst = False

    f.close()
    return modules

  def readOpts(self, argv):
    parser = optparse.OptionParser()

    # algorithm definiting options
    parser.add_option("-c", "--config-file", action="store",
                      type="string", dest="conf",
                      help="specify the configuration file [required]")
    parser.add_option("-a", "--as", action="store",
                      type="int", dest="asid", default=-1, 
                      help="specify the AS router belongs to [required]")
    parser.add_option("-r", "--router-id", action="store",
                      type="int", dest="rid", default=-1, 
                      help="specify the id of the router [required]")
    parser.add_option("-e", "--everyone-customer", action="store_true",
                      default=False, dest="everyone_customer", 
                      help = "Ignore the relations and assume that everybody"
                      " is a customer")
    # run options
    parser.add_option("--run-id", action="store",
                      type="int", dest="run_id", default=123, 
                      help="specify the run id of the current run")
    parser.add_option("-s", "--collect-stats",  action="store",
                      type="int", dest="collect_stats", default=0,
                      help="Collect statistics with interval collect_stats")

    # debugging options
    parser.add_option("--show-cmd-connections", action="store_true",
                      default=False, dest="show_cmd_connections", 
                      help="show command connections")
    parser.add_option("--show-connection-events", action="store_true",
                      default=False, dest="show_connection_events", 
                      help="show connection events")
    parser.add_option("--show-apls-updates", action="store_true",
                      default=False, dest="show_apls_updates", 
                      help="show updates to all pathlets storage")
    parser.add_option("--show-lpls-updates", action="store_true",
                      default=False, dest="show_lpls_updates", 
                      help="show updates to local pathlets storage")
    parser.add_option("--show-rib-in-updates", action="store_true",
                      default=False, dest="show_rib_in_updates", 
                      help="show updates to rib_in")
    parser.add_option("--show-rib-out-updates", action="store_true",
                      default=False, dest="show_rib_out_updates", 
                      help="show updates to rib_out")
    parser.add_option("--show-rrib-out-updates", action="store_true",
                      default=False, dest="show_rrib_out_updates", 
                      help="show updates to rrib_out")
    parser.add_option("--show-gsp-msgs", action="store_true",
                      default=False, dest="show_gsp_msgs", 
                      help="show gossiper message receptions")
    parser.add_option("--show-data-pkts", action="store_true",
                      default=False, dest="show_data_pkts", 
                      help="show processed data packets")
    parser.add_option("--show-vnode-exposures", action="store_true",
                      default=False, dest="show_vnode_exposures", 
                      help="show vnode exposure events")
    parser.add_option("--show-all-events", action="store_true",
                      default=False, dest="show_all_events", 
                      help="show all events")
    parser.add_option("-d", "--debug", action="store_true",
                      default=False, dest="debug", 
                      help="enable debug checks and assertions")


    (opts, args) = parser.parse_args(argv) 

    if len(args) > 1:
      print "Everyting is specified using options"
      parser.print_help()
      sys.exit(2)
    if opts.conf == None or opts.asid == -1 or opts.rid == -1:
      print "Please specify all required options"
      parser.print_help()
      sys.exit(2)

    if opts.show_all_events:
      opts.show_connection_events = True
      #opts.show_apls_updates = True
      #opts.show_lpls_updates = True
      #opts.show_rib_out_updates = True
      #opts.show_rrib_out_updates = True
      #opts.show_rib_in_updates = True
      #opts.show_gsp_msgs = True
      #opts.show_data_pkts = True
      #opts.show_vnode_exposures = True

    return opts


if __name__ == "__main__":
  #import cProfile
  pl = PLRouter(reactor, sys.argv)
  #if pl.id[0] == 1:
  #  cProfile.run("pl.run()", "prof.pic")
  #else:
  pl.run()
   
